=== debian/changelog ===
python-glad (0.1.27-1) unstable; urgency=medium

  * Initial release (Closes: #909335)

 -- Steffen Moeller <moeller@debian.org>  Mon, 17 Sep 2018 12:12:45 +0200
