=== debian/changelog ===
python-glad (0.1.30-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Drop python2 support; Closes: #937790

 -- Sandro Tosi <morph@debian.org>  Sat, 05 Oct 2019 19:33:43 -0400

python-glad (0.1.30-1) unstable; urgency=medium

  * New upstream version.

 -- Steffen Moeller <moeller@debian.org>  Thu, 06 Jun 2019 17:46:45 +0200
