=== debian/control ===
Source: python-glad
Section: graphics
Priority: optional
Maintainer: Steffen Moeller <moeller@debian.org>
Build-Depends: debhelper (>= 11),
 dh-python,
 python3-all,
 python3-setuptools
Standards-Version: 4.2.1
Homepage: https://github.com/Dav1dde/glad
Vcs-Browser: https://salsa.debian.org/python-team/modules/glad
Vcs-Git: https://salsa.debian.org/python-team/modules/glad.git
Testsuite: autopkgtest-pkg-python

Package: python3-glad
Architecture: all
Depends: ${python3:Depends}, ${misc:Depends}
Conflicts: python-glad
Description: GL/GLES/EGL/GLX/WGL Loader-Generator (Python 3)
 This package provides the implementation of what is also available as
 a webservice on
  http://glad.dav1d.de/
 to transform OpenGL specs into an API that one can program against.
 It uses the official Khronos-XML specs to generate a GL/GLES/EGL/GLX/WGL
 Loader made for your needs. Glad currently supports the languages C,
 D and Volt.
 .
 The package is not meant for end users and will not be installed
 by the users of the package that it helped building.  It is a build
 dependency that is prepared to be integrated with CMake or Conan into
 the build process.
 .
 This package installs the library for Python 3.
