=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%python-glad-$1.tar.gz%" \
   https://github.com/Dav1dde/glad/tags \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate
