=== debian/changelog ===
python-glad (2.0.2-0.1) unstable; urgency=medium

  * Non-maintainer upload.

  [ Ondřej Nový ]
  * Use debhelper-compat instead of debian/compat.
  * d/control: Update Vcs-* fields with new Debian Python Team Salsa
    layout.

  [ Debian Janitor ]
  * Trim trailing whitespace.
  * Bump debhelper from old 11 to 12.
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.
  * Bump debhelper from old 12 to 13.

  [ Sebastian Ramacher ]
  * New upstream version 2.0.2 (Closes: #994700)
  * debian/copyright: Update copyright info for 2.0.2
  * debian/control: Add python3-jinja2 to Build-Depends

 -- Sebastian Ramacher <sramacher@debian.org>  Sat, 03 Dec 2022 22:01:09 +0100
