=== debian/control ===
--- 
+++ 
@@ -2,14 +2,15 @@
 Section: graphics
 Priority: optional
 Maintainer: Steffen Moeller <moeller@debian.org>
-Build-Depends: debhelper (>= 11),
+Build-Depends: debhelper-compat (= 13),
  dh-python,
  python3-all,
- python3-setuptools
+ python3-jinja2,
+ python3-setuptools,
 Standards-Version: 4.2.1
 Homepage: https://github.com/Dav1dde/glad
-Vcs-Browser: https://salsa.debian.org/python-team/modules/glad
-Vcs-Git: https://salsa.debian.org/python-team/modules/glad.git
+Vcs-Browser: https://salsa.debian.org/python-team/packages/glad
+Vcs-Git: https://salsa.debian.org/python-team/packages/glad.git
 Testsuite: autopkgtest-pkg-python
 
 Package: python3-glad
